io8254_0        equ    240h
io8254_1        equ    241h
io8254_2        equ    242h
io8254_k        equ    243h
p55a            equ    210h
p55b        equ    211h
p55c            equ    212h
p55ctl        equ    213h
ad_io        equ    220h
led_io        equ    230h

;数据段定义，用于存放程序中用到的各类数据

data segment para
ledcode db 3fh,06h,5bh,4fh,66h,6dh,7dh,07h,7fh,67h,77h,7ch,39h,5eh,79h,71h
led1    db    01h
led3    db    99h,5ah,3ch,0ffh,0ffh,3ch,5ah,99h
data ends


ssg    segment stack
    dw     100 dup()
ssg ends


code     segment
    assume    cs code, ds data, ss ssg

start
    mov        ax, data
    mov        ds, ax
    nop
    mov        dx,p55ctl    ; 将P55芯片控制寄存器的端口地址赋给DX寄存器，准备向其写入控制字来配置P55芯片
    mov     al,10000001b
    out         dx, al

; 配置8254定时器0相关设置
    mov     dx, io8254_k
    mov     al, 36h
    out         dx, al
    mov     ax, 100
    mov     dx, io8254_0
    out         dx, al
    mov     al, ah
    out         dx, al

; 配置8254定时器1相关设置，步骤和定时器0类似
    mov         dx, io8254_k
    mov     al,76h
    out         dx, al
    mov     ax,260
    mov     dx, io8254_1
    out         dx, al
    mov     al, ah
    out         dx, al

; 再次配置P55芯片控制寄存器，更新其控制字为93h
    mov     dx, p55ctl
    mov     al, 93h
    out     dx, al

lop
; 设置启动ADC转换的控制字，此处10000000b表示启动ADC操作
    mov         al, 10000000b
    mov     dx, ad_io     ;启动 adc
    out         dx, al
    mov     dx,ad_io    ;获取adc eoc状态地址
    add         dx, 02h        
    l1
    in         al, dx         ;测试 eoc=1 ？
    test         al, 01h
    jz         l1
    mov     dx, ad_io    ;读数据地址
    inc         dx
    in         al, dx
    call disp
    and        al,0ffh
    jnz         lop3
    inc         al            ;防止初值为0

lop3
    mov     bl,al

lop4
    mov     dx,p55c
    in         al,dx
    and         al,01h        ;判断out1是否为低
    jnz         lop4            ;等待为低
    mov     dx,p55ctl
    mov     al,0fh
    out         dx,al
     mov     dx,io8254_k
    mov     al,0b0h
    out         dx,al
    mov     ax,0
    mov     al,bl
    mov     dx,io8254_2
    out         dx,al
    mov     al,ah
    out         dx,al

lop1
    mov     dx,p55c
    in         al,dx
    and         al,02h
    jz         lop1
    mov     dx,p55ctl
    mov     al,0eh
    out         dx,al

lop2
    mov         dx,p55c
    in         al,dx
    and         al,01h    
    jz         lop2
    jmp     lop

disp proc
    push    bx
    push    dx
    push    ax
    push    cx
    mov     si,offset  ledcode
    mov     bx,si
    mov     ch,al
    cmp     led1,01h;判断亮哪位
    jne     led2
    mov     cl,4        ;亮高位
    ror     al,cl
    and     al,0fh                             
    mov     ah,0
    add     bx,ax
    mov     al,[bx]
    mov     dx,led_io
    out     dx,al
    mov     al,02h
    inc     dx
    nop
    out     dx,al
    call    delay 
    mov     led1,0
    jmp     kkk

    
led2                   ;亮低位
    mov     al,ch
    and     al,0fh
    mov     ah,0
    add     si,ax
    mov     al,[si]
    mov     dx,led_io
    out     dx,al
    mov     al,01h
    Inc     dx
    out     dx,al
    call    delay  
    mov     led1,01h 

kkk
    pop    cx
    pop     ax
    pop     dx
    pop     bx
    ret
disp    endp



delay    proc
    push cx
    mov cx,50h

x1
    loop x1
    pop cx
    ret               ; 返回调用处，结束延时子程序
delay     endp

code ends
end start